module TimeWin
  class Window
    attr_reader :from, :to
    def initialize from, to
      @from, @to = from.to_time, to.to_time
      raise "Invalid time bounds from > to -- #{@from} > #{@to}" if !valid?
    end

    def valid?
      @from <= @to
    end

    def nb_seconds
      @from - @to
    end

    def nb_minutes
      self.seconds / 60
    end

    def nb_hours
      self.minutes / 60
    end

    def nb_days
      self.hours / 24
    end

    def shift offset
      Window.new(@from+offset, @to+offset)
    end

    def to_s
      "[#{from} --> #{@to}]"
    end
  end
end
